
////LED MATRIX
//Pin connected to DS of first 74HC595
int dataPin = 2;
//Pin connected to ST_CP of 74HC595
int latchPin = 3;
//Pin connected to SH_CP of 74HC595
int clockPin = 4;

////PUSHBUTTONS
int buttonpin[] = {A0,A3,A1,A2};
int buttonprevious[4];

////PLAYER VARIABLES
int px,py,pdx,pdy,pt,lx,ly = 0;

bool scan = true;


//movement controls
void control(int button)
{
  Serial.println(button);
  switch (button){
    case 0:
    if (getmap(px,py-1)==false){
      pdy=-1;
      py--;
    }
    break;
    
    case 1:
    if (getmap(px,py+1)==false){
      pdy=1;
      py++;
    }
    break;
    
    case 2:
    if (getmap(px-1,py)==false){
      pdx=-1;
      px--;
    }
    break;

    case 3:
    if (getmap(px+1,py)==false){
      pdx=1;
      px++;
    }

  }
    Serial.print(px);
    Serial.print(" : ");
    Serial.println(py);
}


//display map on LED matrix
void showmap(void)
{
  if (not py){return;};
  byte output[10] ={};
  for(int iy=py-2;iy<py+3;iy++){
    uint8_t row = 0;
    for(int ix=px-2;ix<px+3;ix++){
      int c = getmap(ix,iy);
      if (ix == px and iy==py and millis()%500 < 250){c=true;}
      if (ix == lx and iy==ly and millis()%200 < 150){c=true;}
      int d = 2*(ix-px+2);
      if (d!=0){
      if (c == true) row |= (1<< d-1);
      }
      if (c == true) row |= (1<< d);
    }
  int d = 2*(iy-py+2);
  //char* scope = row +'0';
  //strncpy(scope,1,9);
  
  output[d] = row;
  output[d+1] = row;
  }
   for (int row=1; row<9; row++){
    
        digitalWrite(latchPin, LOW);
        shiftOut(dataPin, clockPin, MSBFIRST, 1 << row-1);
        shiftOut(dataPin, clockPin, MSBFIRST, ~output[(row)]);  
        digitalWrite(latchPin, HIGH);
      }
}


