
void setup() {
  //led matrix
  pinMode(latchPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(dataPin, OUTPUT);
  //piezo
  pinMode(tonePin, OUTPUT);
  //buttons
  for(int i=0; i<4; i++){
    pinMode(buttonpin[i], INPUT_PULLUP);
  }

  Serial.begin(9600); 
  SPI.begin(); 
  rfid.PCD_Init();
  //playMelody(Melody0, Melody0_Length, tempoToPlay);
  mkmaze();
}


void loop() {
    noTone(tonePin);
    if (scan){
      scanning();
      return;
    }
     
     showmap();
     
    //check buttons for input
    for(int i=0; i<4; i++){
      int state = digitalRead(buttonpin[i]);
      if (state != buttonprevious[i]){
        if (state == LOW){
          control(i);
        }
      }
      buttonprevious[i] = state;
      
  }
  //RESET
  for(int i=0; i<4; i++){
    if(digitalRead(buttonpin[i]) == HIGH) {break;}
    if(i==3) {scan=true;}
  }
  //check if ladder is reached
  if (px == lx and py == ly){
    playMelody(Melody0, 20, 1);
    randomSeed(millis());
    mkmaze();
  }
}


